<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function form_objectclass($name)
{
	global $entry, $entry2, $phase;
	static	$nboc=0;

	print("<input type=\"hidden\" name=\"entry[objectclass][".$nboc."]\" value=\"".$name."\">");
	$nboc++;
}
function form_hidden($key, $name)
{
	global $entry, $entry2, $phase;

	if (!$phase)
	{
		if (is_array($entry[$name]))
			$val=$entry[$name][0];
		else
			$val=$entry[$name];
		print("<INPUT type=\"hidden\" name=\"entry2[".$key."]\" value=\"".$val."\" >");
	}
	else
		print("<INPUT type=\"hidden\" name=\"entry2[".$key."]\" value=\"".$entry2[$key]."\" >");
}

function form_sep()
{
	print("<TR><TD colspan=2></TD></TR>");
}

function form_display($title, $name)
{
	global $entry;

	print("<TR><TD class=col5>".$title."</TD><TD>".$entry[$name][0]."</TD></TR>");
}

function form_display_list($title, $name, $a1, $a2)
{
	global $entry, $com, $phase;
		
	print("<TR><TD class=col1>".$title."s</TD><TD>");
	unset($members);
	for ($i=0; $i<count($a1); $i++)
	{
		if ($a1[$i]==$entry[$name][0])
		{
			if ($members!="")
			{
				$members.="<BR>";
			}
			$members.=$a2[$i];
		}
	}
	if ($members)
	{
		print($members);
	}
	else
	{
		print("No ".$title);
	}
	print("</TD></TR>");
}

function form_text($title, $name, $size)
{
	global $entry, $com, $phase, $usermgr, $r;

	//$entry[$name][0] = $usermgr->get_attr_value($name);
	$entry[$name][0] = $r->get_result($name);
	print("<TR><TD class=col1>".$title."</TD><TD>");
	switch($com)
	{
	case 0:
	case 2:
		print($entry[$name][0]);
		break;
	case 1:
		print("<INPUT type=\"text\" name=\"entry[".$name."][0]\" value=\"".$entry[$name][0]."\" size=".$size.">");
		break;
	case 3:
		if (!$phase)
			print("<INPUT type=\"text\" name=\"entry[".$name."][0]\" size=".$size.">");
		else
			print("<INPUT type=\"text\" name=\"entry[".$name."][0]\" value=\"".$entry[$name][0]."\" size=".$size.">");
		break;
	}
	print("</TD></TR>");
}

function form_textarea($title, $name, $rows, $cols)
{
	global $entry, $com, $phase;

	print("<TR><TD class=col1>".$title."</TD><TD>");
	switch($com)
	{
	case 0:
		print($entry[$name][0]);
		break;
	case 1:
		print("<TEXTAREA name=\"entry[".$name."][0]\" rows=".$rows." cols=".$cols.">".$entry[$name][0]."</TEXTAREA>");
		break;
	case 3:
		if (!$phase)
			print("<TEXTAREA name=\"entry[".$name."][0]\" rows=".$rows." cols=".$cols."></TEXTAREA>");
		else
			print("<TEXTAREA name=\"entry[".$name."][0]\" rows=".$rows." cols=".$cols.">".$entry[$name][0]."</TEXTAREA>");
		break;
	}
	print("</TD></TR>");
}

function form_select($title, $name, $a1, $a2)
{
	global $entry, $com, $phase;

	if ($com!=3 || $phase)
		$b=array_search($entry[$name][0], $a2);
	print("<TR><TD class=col1>".$title."</TD><TD>");
	switch($com)
	{
	case 0:
		if ($a1[$b] == $entry[$name][0])
			print($a1[$b]);
		else
			print($a1[$b]." (".$a2[$b].")");
		break;
	case 1:
	case 3:
		print("<SELECT name=\"entry[".$name."][]\">");
		for ($i=0; $i<count($a1); $i++)
		{
			if (($com!=3 || $phase) && $entry[$name][0]==$a2[$i])
				print("<OPTION value=\"".$a2[$i]."\" selected>".$a1[$i]."</OPTION>");
			else
				print("<OPTION value=\"".$a2[$i]."\">".$a1[$i]."</OPTION>");
		}
		print("</SELECT>");
		break;
	}
	print("</TD></TR>");
}

function form_multiselect($title, $name, $a1, $a2, $isnullok)
{
	global $entry, $com, $phase;

	print("<TR><TD class=col1>".$title."s</TD><TD>");
	print("<TABLE class=invisible align=center>");
	print("<TR><TD class=invisible>");
	if ($com!=0 && $com!=2)
		print("<SELECT name=\"entry[".$name."][]\" multiple>");
	if ($entry[$name]["count"]==0 && ($com==0 || $com==2))
	{
		print("<TR><TD class=invisible colspan=3>No ".$title);
		if (!isnullok)
			print(" (this should never happend)");
		print("</TD></TR>");
	}
	else
	{
		if (($com==1 || $com==3) && $isnullok)
		{
			if ($entry[$name]["count"]==0)
				print("<OPTION value=\"\" selected>&lt;void&gt;</OPTION>");
			else
				print("<OPTION value=\"\">&lt;void&gt;</OPTION>");
		}
		for ($i=0; $i<count($a1); $i++)
		{
			switch($com)
			{
			case 0:
			case 2:
				if (in_array($a1[$i], $entry[$name]))
					print($a1[$i]."<BR>");
				break;
			case 1:
				if (in_array($a1[$i], $entry[$name]))
					print("<OPTION value=\"".$a2[$i]."\" selected>".$a1[$i]."</OPTION>");
				else
					print("<OPTION value=\"".$a2[$i]."\">".$a1[$i]."</OPTION>");
				break;
			case 3:
				if (!$phase)
					print("<OPTION value=\"".$a2[$i]."\">".$a1[$i]."</OPTION>");
				else
				{
					if (in_array($a1[$i],$entry[$name]))
						print("<OPTION value=\"".$a2[$i]."\" selected>".$a1[$i]."</OPTION>");
					else
						print("<OPTION value=\"".$a2[$i]."\">".$a1[$i]."</OPTION>");
				}
				break;
			}
		}
		if ($com!=0 && $com!=2)
		{
			print("</SELECT></TD><TD width=30></TD>");
			print("<TD class=invisible>To add or remove items<BR> select or unselect them<BR>with Ctrl and Shift Keys.");
			if ($isnullok)
				print("<BR> Select &lt;void&gt; to have<BR>no ".$title."s.");
		}
		print("</TD></TR>");
	}

	print("</TABLE></TD></TR>");
}

function form_multientry($title, $name, $key, $rows, $cols)
{
	global $entry, $com, $phase, $usermgr, $r;

	//$entry[$name] = $usermgr->get_attr_value($name);
	$entry[$name] = $r->get_result($name);
	print("<TR><TD class=col1>".$title);
	if ($com!=0)
		print("<BR>(one per line)");
	print("</TD><TD>");
	$data1="";
	$data2="";
	$i=0;
	while ($entry[$name][$i]!="")
	{
		if ($i==0)
		{
			$data1.=$entry[$name][$i];
			$data2.=$entry[$name][$i];
		}
		else
		{
			$data1.="\n".$entry[$name][$i];
			$data2.="<BR>".$entry[$name][$i];
		}
		$i++;
	}
        switch($com)
        {
        case 0:
                print($data2);
                break;
        case 1: 
                print("<TEXTAREA name=\"entry2[".$key."]\" rows=".$rows." cols=".$cols.">".$data1."</TEXTAREA>");
                break;
        case 3: 
                if (!$phase)
        		print("<TEXTAREA name=\"entry2[".$key."]\" rows=".$rows." cols=".$cols."></TEXTAREA>");
                else    
			print("<TEXTAREA name=\"entry2[".$key."]\" rows=".$rows." cols=".$cols.">".$data1."</TEXTAREA>");                    
		break;
	}       
	print("</TD></TR>");
}

function form_checkbox($title, $name, $default)
{
	global $entry, $entry2, $com, $phase;

	$val=$entry[$name][0];
	
	if ($val)
	{
		$val2="True";
		$val3="checked";
	}
	else
	{
		$val2="False";
		$val3="";
	}

	switch($com)
        {
        case 0:
		print("<TR><TD class=col1>".$title."</TD><TD>".$val2."</TD></TR>");
                break;
        case 1:
		print("<TR><TD class=col1>".$title."</TD><TD><input name=\"entry2[".$name."][0]\" type=\"checkbox\" ".$val3."></TD></TR>");
                break;
        case 3: 
                if (!$phase)
		{
			if ($default)
				print("<TR><TD class=col1>".$title."</TD><TD><input name=\"entry2[".$name."][0]\" type=\"checkbox\" checked></TD></TR>");
			else
				print("<TR><TD class=col1>".$title."</TD><TD><input name=\"entry2[".$name."][0]\" type=\"checkbox\"></TD></TR>");
		}
                else
			print("<TR><TD class=col1>".$title."</TD><TD><input name=\"entry2[".$name."][0]\" type=\"checkbox\" ".$val3."></TD></TR>");
		break;
	}       
}

function form_fileupload($title, $name, $maxsize)
{
	global $entry, $com, $phase;

	switch($com)
        {
        case 0:
		// Display
                break;
        case 1:
		// Display
		print("<INPUT type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$maxsize."\" >");
		print("<TR><TD class=col1>".$title."</TD><TD><input name=\"".$name."\" type=\"file\"></TD></TR>");
                break;
        case 3: 
		print("<INPUT type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$maxsize."\" >");
                if (!$phase)
			print("<TR><TD class=col1>".$title."</TD><TD><input name=\"".$name."\" type=\"file\"></TD></TR>");
                else    
			// Display
			print("<TR><TD class=col1>".$title."</TD><TD><input name=\"".$name."\" type=\"file\"></TD></TR>");
		break;
	}       
}

function form_submit($title, $colnb, $comnb, $com2nb)
{
	print("<TR><TD class=col".$colnb." colspan=2><INPUT type=submit name=\"submit\" value=\"".$title."\" onclick=\"com.value=".$comnb."; com2.value=".$com2nb."\"></TD></TR>");
}

function get_from_multientry($name, $dat)
{
	global $entry, $entry2;

	unset($entry[$name]);
	$entry[$name]=explode("\n", $entry2[$dat]);
	if (!$entry[$name][sizeof($entry[$name])-1])
		array_pop($entry[$name]);
}

function get_from_checkbok($name)
{
	global $entry, $entry2;
	
	unset($entry[$name]);
	if ($entry2[$name])
		$entry[$name][0]="1";
	else
		$entry[$name][0]="0";
}

function debug_display_array_print ($item, $key)
{
	echo "$key. $item<br>\n";
	if (is_array($item))
		array_walk ($item, 'debug_display_array_print');
}

function debug_display_array($a)
{
	reset($a);
	array_walk ($a, 'debug_display_array_print');
}

function process_entry_write()
{
	global	$entry;

	reset($entry);
	array_walk($entry, 'process_entry_write2');

	for ($i=0; $i<$entry[count]; $i++)
		unset($entry[$i]);
	unset($entry[count]);
	unset($entry[dn]);
}

function process_entry_write2(&$item, $key)
{
	global	$entry, $com;

	if ($item[0]=="")
	{
		unset($entry[$key][0]);
		if ($com==3)
			unset($entry[$key]);
	}
	elseif (is_string($entry[$key][0]))
	{
		$entry[$key][0]=utf8_encode($entry[$key][0]);
	}

	unset($item[count]);
}

function process_entry_read()
{
	global	$entry;

	reset($entry);
	array_walk($entry, 'process_entry_read2');
}

function process_entry_read2(&$item, $key)
{
	global	$entry, $com;

	if (is_string($entry[$key][0]))
	{
		$entry[$key][0]=utf8_decode($entry[$key][0]);
	}
}

function test_attribute_required($name, $key)
{
	global $error, $entry, $com;

	if ($entry[$key][0]=="")
	{
		print("<TR><TD class=col3 colspan=2>You must specify a ".$name."</TD></TR>");
		$error=true;
	}
}

function test_attribute_without_space($name, $key)
{
	global $error, $entry;
		
	if (strpos($entry[$key][0], " "))
	{
		print("<TR><TD class=col3 colspan=2>The ".$name." must not contain any space character</TD></TR>");
		$error=true;
	}
}

function test_attribute_is_int($name, $key)
{
	global $error, $entry;

	if (is_numeric($entry[$key][0])==false || is_int(0+$entry[$key][0])==false)
	{
		print("<TR><TD class=col3 colspan=2>".$name." must be an integer value</TD></TR>");
		$error=true;
	}
}

function hex2bin($data)
{
	$len = strlen($data);
	for($i=0;$i<$len;$i+=2)
	{
		$newdata .= pack("C",hexdec(substr($data,$i,2)));
	}
	return $newdata;
}

function test_password_is_crypted()
{
	global $entry;

	if ($entry["userpassword"][0]!="")
	{
		if (substr($entry["userpassword"][0], 0, 7)!="{crypt}")
		{
			$salt=substr(ereg_replace("[^a-zA-Z0-9./]", "", crypt(rand(10000000,99999999), rand(10,99))), 2, 2);
			$entry["userpassword"][0]="{crypt}".crypt($entry["userpassword"][0], "$1$".$salt);
		}
	}
}

function propagate_changes($key, $oldvalue, $newvalue)
{
	global $ds, $config, $entry, $entry2, $object;
	
	$key2=strtolower($key);
	$sr = ldap_search($ds, $config[base], $key."=".$oldvalue);
	if ($sr)
	{
		unset($a);
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		if($nb)
		{       
			for ($i=0; $i<$nb; $i++)
			{
				$found = false;
				$entry3 =& $a[$i][$key2];
				$name=$a[$i][dn];
				if ($entry3)
				{
					$j=-1;
					do
					{
						$j++;
						if ($entry3[$j]==$oldvalue)
							$found=true;
					} while (($j<$entry3[count]) && !$found);
				}

				if ($found)
				{
					$entry3[$j]=$newvalue;
					$copy=copy_array_without_bad_keys($a[$i]);

					if (ldap_modify($ds, $name, $copy))
						print("<TR><TD class=col1 colspan=2>".$name."</TD></TR>");
					else
						print("<TR><TD class=col3 colspan=2><BIG>Operation failed : ".ldap_error($ds)."</BIG><BR>(".$name.")</TD></TR>");
				}
				print("<br>");
			}
		}
	}
	ldap_free_result($sr);
}

function copy_array_without_bad_keys($a)
{
	$b=array();
	
	reset ($b);
	while (list ($key, $val) = each ($a))
	{
		unset($c);
		$c=array();
		if (is_array($val))
		{
			for($i=0; $i<$val[count]; $i++)
				$c[$i]=$a[$key][$i];
			$b[$key]=$c;
		}
	}

	return $b;
}

?>
